﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Menus;

namespace AddNodeInEditMode
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        
        public MainWindow()
        {
            InitializeComponent();
            MyTree.ItemsSource = DataUtil.CategoriesAndProducts;
           
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            XamDataTreeNode node = MyTree.ActiveNode;

            if (node == null)
            {
                msgTxt.Text = "Active node not found";
                return;
            }

            if (node.Data.GetType() == typeof(Product))
            {
                msgTxt.Text = "Select category in order to add product";
                return;
            }

            Category cat = (Category) node.Data;

           
            Product prod = new Product();
            prod.CategoryID = cat.CategoryID;
            prod.ProductName = cat.CategoryName + " Name";
            prod.ProductID = DataUtil.Products.Count;
            cat.Products.Add(prod);

            XamDataTreeNode newNode = node.Nodes[node.Nodes.Count - 1];
            newNode.IsActive = true;
           
            MyTree.EnterEditMode(newNode);


           
        }

        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {

           

            XamDataTreeNode node = MyTree.ActiveNode;

            if (node == null)
            {
                msgTxt.Text = "Active node not found";
                return;
            }


            if (node.Data.GetType() == typeof(ProductStuff))
            {
                msgTxt.Text = "Cannot add nodes to this level";
                return;
            }
            
            if (node.Data.GetType() == typeof(Category))
            {

                Category cat = (Category)node.Data;
                
                Product prod = new Product();
                prod.CategoryID = cat.CategoryID;
                prod.ProductID = DataUtil.Products.Count;
                cat.Products.Add(prod);

         
            }

            if (node.Data.GetType() == typeof(Product))
            {

                Product prod = (Product)node.Data;

                ProductStuff stuff = new ProductStuff();
                stuff.ProductID = prod.ProductID;
                stuff.ProductStuffID = DataUtil.Stuffs.Count;
                prod.Stuffs.Add(stuff);


            }



            XamDataTreeNode newNode = node.Nodes[node.Nodes.Count - 1];
            node.IsSelected = false;
            node.IsActive = false;
            newNode.IsActive = true;
            newNode.IsSelected = true;

            MyTree.EnterEditMode(newNode);

           
            MyTree.Focus();

        }

        private void MyTree_NodeEnteredEditMode(object sender, TreeEditingNodeEventArgs e)
        {
            TextBox tb = (TextBox)e.Editor;
            if (tb.Text == "")
                tb.Text = "New Node";

        }

       
        

       
    }
}
